"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initLocalFileSyncAdapter = void 0;
var ipc_events_const_1 = require("./shared-with-frontend/ipc-events.const");
var fs_1 = require("fs");
var main_1 = require("electron-log/main");
var electron_1 = require("electron");
var main_window_1 = require("./main-window");
var initLocalFileSyncAdapter = function () {
    electron_1.ipcMain.handle(ipc_events_const_1.IPC.FILE_SYNC_SAVE, function (ev, _a) {
        var filePath = _a.filePath, dataStr = _a.dataStr, localRev = _a.localRev;
        try {
            console.log(ipc_events_const_1.IPC.FILE_SYNC_SAVE, filePath);
            console.log('writeFileSync', filePath, !!dataStr);
            (0, fs_1.writeFileSync)(filePath, dataStr);
            return getRev(filePath);
        }
        catch (e) {
            (0, main_1.log)('ERR: Sync error while writing to ' + filePath);
            (0, main_1.error)(e);
            return new Error(e);
        }
    });
    electron_1.ipcMain.handle(ipc_events_const_1.IPC.FILE_SYNC_GET_REV_AND_CLIENT_UPDATE, function (ev, _a) {
        var filePath = _a.filePath, localRev = _a.localRev;
        throw new Error('REMOVE AS IMPLEMENTED OTHERWISE');
        // try {
        //   console.log(IPC.FILE_SYNC_GET_REV_AND_CLIENT_UPDATE, filePath, localRev);
        //   console.log('getRev and stuuff');
        //   readFileSync(filePath);
        //   return {
        //     rev: getRev(filePath),
        //   };
        // } catch (e) {
        //   log('ERR: Sync error while getting meta for ' + filePath);
        //   error(e);
        //   // TODO improve
        //   return 'NO_REMOTE_DATA';
        // }
    });
    electron_1.ipcMain.handle(ipc_events_const_1.IPC.FILE_SYNC_LOAD, function (ev, _a) {
        var filePath = _a.filePath, localRev = _a.localRev;
        try {
            console.log(ipc_events_const_1.IPC.FILE_SYNC_LOAD, filePath, localRev);
            var dataStr = (0, fs_1.readFileSync)(filePath, { encoding: 'utf-8' });
            console.log('READ ', dataStr.length);
            return {
                rev: getRev(filePath),
                dataStr: dataStr,
            };
        }
        catch (e) {
            (0, main_1.log)('ERR: Sync error while loading file from ' + filePath);
            (0, main_1.error)(e);
            return new Error(e);
        }
    });
    electron_1.ipcMain.handle(ipc_events_const_1.IPC.CHECK_DIR_EXISTS, function (ev, _a) {
        var dirPath = _a.dirPath;
        try {
            var r = (0, fs_1.readdirSync)(dirPath);
            console.log(r);
            return true;
        }
        catch (e) {
            (0, main_1.log)('ERR: error while checking dir ' + dirPath);
            (0, main_1.error)(e);
            return new Error(e);
        }
    });
    electron_1.ipcMain.handle(ipc_events_const_1.IPC.PICK_DIRECTORY, function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, canceled, filePaths;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, electron_1.dialog.showOpenDialog((0, main_window_1.getWin)(), {
                        properties: ['openDirectory'],
                    })];
                case 1:
                    _a = _b.sent(), canceled = _a.canceled, filePaths = _a.filePaths;
                    if (canceled) {
                        return [2 /*return*/, undefined];
                    }
                    else {
                        return [2 /*return*/, filePaths[0]];
                    }
                    return [2 /*return*/];
            }
        });
    }); });
};
exports.initLocalFileSyncAdapter = initLocalFileSyncAdapter;
var getRev = function (filePath) {
    var fileStat = (0, fs_1.statSync)(filePath);
    return fileStat.mtime.getTime().toString();
};
//# sourceMappingURL=local-file-sync.js.map